Bug 98539 - DIALOG: Improvements to the Find & Replace dialog
Summary: DIALOG: Improvements to the Find & Replace dialog
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium normal
Assignee: Akshay Deep
QA Contact:
URL:
Whiteboard: target:5.2.0
Keywords:
Depends on:
Blocks:
 
Reported: 2016-03-09 07:30 UTC by Akshay Deep
Modified: 2016-08-14 10:59 UTC (History)
10 users (show)

See Also:
Crash report or crash signature:


Attachments
expanded UI for find/replace (56.08 KB, image/png)
2016-03-09 07:30 UTC, Akshay Deep
Details
Find-replace dialog compact UI (24.55 KB, image/png)
2016-03-09 07:32 UTC, Akshay Deep
Details
Find-replace dialog - suggestion for Writer (64.08 KB, image/jpeg)
2016-04-26 17:50 UTC, Timur
Details
New Find&Replace dialog box with the French UI (96.57 KB, image/png)
2016-07-09 17:01 UTC, Jean-Baptiste Faure
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Akshay Deep 2016-03-09 07:30:03 UTC
Created attachment 123417 [details]
expanded UI for find/replace

Current Find/Replace dialog consumes screen space and eclipses the document. This problem can be solved by reducing the dimensions of Find/replace dialog.

UI suggested by Yousuf Philips is attached to this enhancement report.

Labels and their respective combobox box are horizontally aligned to reduce height of the dialog. Buttons have been moved to a separate dock.
Comment 1 Akshay Deep 2016-03-09 07:32:25 UTC
Created attachment 123418 [details]
Find-replace dialog compact UI
Comment 2 Yousuf Philips (jay) 2016-03-09 07:38:27 UTC
Thanks for the work Akshay. It looks great.

Does anyone from UX have any additional suggestions.
Comment 3 Cor Nouws 2016-03-09 09:49:26 UTC
Hi Aksha,

Thanks for the design. I have some questions:

1. Why do you choose to place Find All, Find Next, Replace and REplace All in one line?
To me it looks there is a natural difference between Find and Replace, which is supported by placing the groups in relation to the Find and Replace field.

2. This is for Calc. What are the ideas for Writer, Impress?

Further: do take into account the idea in issue 98417 please.

And if possible: issue 98544 is UI related and annoying too.

thanks a lot!
Cor
Comment 4 Yousuf Philips (jay) 2016-03-09 10:13:37 UTC
Hi Cor,

Just to further clarify, this is my suggested design.

(In reply to Cor Nouws from comment #3)
> 1. Why do you choose to place Find All, Find Next, Replace and REplace All
> in one line?
> To me it looks there is a natural difference between Find and Replace, which
> is supported by placing the groups in relation to the Find and Replace field.

The primary two buttons that users would constantly be using in the dialog are the find Find Next and Replace buttons, so its important that they be next to each other to reduce mouse movement and tab movement.

> 2. This is for Calc. What are the ideas for Writer, Impress?

They all use the same dialog UI file but hide or show different checkbox options.

> Further: do take into account the idea in issue 98417 please.

Yes i initially asked him to work on that and we decided to redesign the dialog as well.

> And if possible: issue 98544 is UI related and annoying too.

Well it shouldnt open the options if one option is enabled, it should remember the state of whether the 'other options' was visible or hidden. I believe someone started work on this functionality, but it seems to be broken (bug 98437).
Comment 5 Jean-Francois Nifenecker 2016-03-09 10:31:54 UTC
(In reply to Akshay Deep from comment #0)
> Created attachment 123417 [details]
> expanded UI for find/replace
> 
> Current Find/Replace dialog consumes screen space and eclipses the document.
> This problem can be solved by reducing the dimensions of Find/replace dialog.
> 
> UI suggested by Yousuf Philips is attached to this enhancement report.
> 
> Labels and their respective combobox box are horizontally aligned to reduce
> height of the dialog. Buttons have been moved to a separate dock.


The idea of a smaller F & R dialog box is very interesting.

Please keep im mind, though, that some languages are not as compact as EN is. For instance FR and GE have quite longer strings than EN. As a consequence, placing the buttons side to side implies the box to be widened to accommodate these languages strings.

My 2 euro-cents,
Comment 6 V Stuart Foote 2016-03-09 15:38:13 UTC
(In reply to Jean-Francois Nifenecker from comment #5)
> The idea of a smaller F & R dialog box is very interesting.
> 
> Please keep im mind, though, that some languages are not as compact as EN
> is. For instance FR and GE have quite longer strings than EN. As a
> consequence, placing the buttons side to side implies the box to be widened
> to accommodate these languages strings.
> 
> My 2 euro-cents,

Since this is .ui based now, the packing choices should allow for wider button labels with l10n actions. The dialog can expand horizontally.

In refactoring to prepare for a Sidebar instance (bug 95404), these layout changes are fine--but mockups/clips for appearance of the Impress, Writer versions would be helpful. 

The Sidebar Deck container will bring a new aspect ratio to the dialog, so these adjustments to the current dialog layout may end up shifting when packed for the Sidebar. They may require adjustment to .ui attachment then.
Comment 7 V Stuart Foote 2016-03-09 15:39:50 UTC
> In refactoring to prepare for a Sidebar instance (bug 95404), these layout

s/bug 95404/bug 95405/
Comment 8 Thorsten Behrens (CIB) 2016-03-12 10:24:56 UTC
(In reply to Akshay Deep from comment #0)
> Current Find/Replace dialog consumes screen space and eclipses the document.
> This problem can be solved by reducing the dimensions of Find/replace dialog.
>
Great work there - which is happening in https://gerrit.libreoffice.org/#/c/23057/ for those interested in code.

I disagree with the removal of the end/beginning notification though - anectodal evidence has it people use that to fixup new parts of their documents (which tend to be at the end). I'm one of those. ;)
Comment 9 Commit Notification 2016-04-04 08:54:15 UTC
Akshay Deep committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=beeef93480fae65840646e4e36aa888efe92579a

tdf#98417, tdf#98539: DIALOG: Improvements to the Find & Replace dialog.

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 Eike Rathke 2016-04-25 13:20:22 UTC
Can we please get back that the Wildcards button is grouped with the Regular expressions and Similarity search buttons? They belong together as they are mutually exclusive search algorithms. Best would even be if they were a radio button group, not sure though if that fits with how the buttons are currently handled in the dialog code, i.e. Wildcards being only displayed in Calc and Similarity activating the suboptions.
Comment 11 Timur 2016-04-26 17:50:50 UTC
Created attachment 124657 [details]
Find-replace dialog - suggestion for Writer

Previous comment seems to be for Calc.

And for Writer, I'd like to see Paragraph Styles and maybe Comments in compact UI, as suggested. I have Asian languages disabled.
Reason: I open expanded UI for Paragraph Styles rather often.
I know that related Cell Styles is in expanded in Calc, but if that's the price, it's better to have Cell Styles up in compact and Formatted display down in expanded.

I notice there're no tooltips, they'd be nice, at least for some options. 
I don't know what (new from 5.1) "Formatted display" is used for. https://help.libreoffice.org/Common/Find_and_Replace doesn't explain and it should. Maybe another bug. 
I guess it should be obvious, but it's not, sorry.

And for both: Similarities.. button is too small. 
And Other options state should be remembered. I'd like to keep it open all the time and not to expand it each time.
Comment 12 Óvári 2016-06-28 05:12:01 UTC
For a Writer document with one line like:

abc@email.com, xyz@email.com, qwertz@email.com

How would “, ” be replaced with an “Enter”?

Thank you

Version: 5.2.0.1 (x64)
Build ID: fcbcb4963bda8633ba72bd2108ca1e802aad557d
CPU Threads: 2; OS Version: Windows 6.29; UI Render: default
Comment 13 V Stuart Foote 2016-06-28 12:34:21 UTC
(In reply to Óvári from comment #12)
> For a Writer document with one line like:
> 
> abc@email.com, xyz@email.com, qwertz@email.com
> 
> How would “, ” be replaced with an “Enter”?
> 
> Thank you
> 
> Version: 5.2.0.1 (x64)
> Build ID: fcbcb4963bda8633ba72bd2108ca1e802aad557d
> CPU Threads: 2; OS Version: Windows 6.29; UI Render: default

Done already trivial:
regular expresions checked active, match case checked active
then...
Find: \,
Replace: \n
Comment 14 Óvári 2016-06-29 11:08:40 UTC
(In reply to V Stuart Foote from comment #13)
> Done already trivial:
> regular expresions checked active, match case checked active
> then...
> Find: \,
> Replace: \n
Thank you kindly for your response.

Please see bug 100672.
Comment 15 Timur 2016-06-30 08:55:16 UTC
Can we have a follow up on Comment 10 and Comment 11? Thank you.
Comment 16 Jean-Baptiste Faure 2016-07-09 17:01:21 UTC
Created attachment 126134 [details]
New Find&Replace dialog box with the French UI

In the French UI the new F&R dialog box is far wider than the previous one. 
Here is a screen copy of LO 5.2 Writer maximized with the F&R dialog box.

I would prefer if the five buttons dock could be splitted in 2 rows when the user try to make the dialog box less wide.

Best regards. JBF